﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace NoRecordsGridView
{
    public partial class MainPage : UserControl, INotifyPropertyChanged
    {
        private ObservableCollection<DataItem> _dataItems;
        private bool? _hasNoRecords;

        public MainPage()
        {
            InitializeComponent();
            DataContext = this;
        }

        public void LoadWithData()
        {
            DataItems = new ObservableCollection<DataItem>
                            {
                                new DataItem {Name = "Name 1", Class = "Class 1", Description = "Desc 1"},
                                new DataItem {Name = "Name 1", Class = "Class 1", Description = "Desc 1"},
                                new DataItem {Name = "Name 1", Class = "Class 1", Description = "Desc 1"},
                                new DataItem {Name = "Name 1", Class = "Class 1", Description = "Desc 1"},
                                new DataItem {Name = "Name 1", Class = "Class 1", Description = "Desc 1"},
                                new DataItem {Name = "Name 1", Class = "Class 1", Description = "Desc 1"},
                                new DataItem {Name = "Name 1", Class = "Class 1", Description = "Desc 1"},
                                new DataItem {Name = "Name 1", Class = "Class 1", Description = "Desc 1"},
                                new DataItem {Name = "Name 1", Class = "Class 1", Description = "Desc 1"},
                                new DataItem {Name = "Name 1", Class = "Class 1", Description = "Desc 1"},
                                new DataItem {Name = "Name 1", Class = "Class 1", Description = "Desc 1"},
                                new DataItem {Name = "Name 1", Class = "Class 1", Description = "Desc 1"},
                                new DataItem {Name = "Name 1", Class = "Class 1", Description = "Desc 1"}
                            };
            HasNoRecords = !DataItems.Any();
        }

        public void LoadWithoutData()
        {
            DataItems = new ObservableCollection<DataItem>();
            HasNoRecords = !DataItems.Any();
        }

        public ObservableCollection<DataItem> DataItems
        {
            get { return _dataItems; }
            set
            {
                _dataItems = value;
                OnPropertyChanged("DataItems");
            }
        }

        public bool? HasNoRecords
        {
            get { return _hasNoRecords; }
            set
            {
                _hasNoRecords = value;
                OnPropertyChanged("HasNoRecords");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected void OnPropertyChanged(string propertyName)
        {
            if (this.PropertyChanged != null)
            {
                this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        private void WithData_Click(object sender, RoutedEventArgs e)
        {
            LoadWithData();
        }

        private void WithoutData_Click(object sender, RoutedEventArgs e)
        {
            LoadWithoutData();
        }
    }

    public class DataItem
    {
        public string Name { get; set; }
        public string Class { get; set; }
        public string Description { get; set; }
    }
}
